/*
 * main.c
 *  
 *
 * Created by mercadal on Fri Feb 01 2002.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "cmfgetln.h"
#include "common.h"
#include "parsefunctions.h"


void usage(void);
void runParse(FILE *, FILE *);


int main(int argc, char *argv[])
{
    char *inname, *oname, *udefname;
    extern char *optarg;
    int ch;
    FILE *infile, *outfile, *udeffile;
    
    
    inname = oname = udefname = NULL;
    infile = outfile = udeffile = NULL;
    
    while ((ch = getopt(argc, argv, "i:o:u:")) != -1)
        switch (ch) {
            case 'i':
                inname = strdup(optarg);
                break;
            case 'o':
                oname = strdup(optarg);
                break;
            case 'u':
                udefname = strdup(optarg);
                break;
            case '?':
            case 'v':
            default:
                usage();
                /* NOTREACHED */
        }

    if (inname != NULL) {
        if ((infile = fopen(inname, "r")) == NULL) {
            perror(inname);
            exit(1);
        }
    } else {
        infile = fopen("/dev/stdin", "r");
    }
    

    if (oname != NULL) {
        if ((outfile = fopen(oname, "w")) == NULL) {
            perror(oname);
            exit(1);
        }
    } else {
        outfile = fopen("/dev/stdout", "w");
    }
    

    if (udefname != NULL)
        if ((udeffile = fopen(udefname, "r")) == NULL) {
            perror(udefname);
            exit(1);
        }

    (void)fprintf(outfile, "<!--HTML output by rss2html from %s-->\n", (inname) ? inname : "the standard input");
    
    if (inname)
        free(inname);
    if (oname)
        free(oname);
        
    if (udefname)
        free(udefname);

    initializeTags(infile, outfile, udeffile);
    runParse(infile, outfile);
    uninitializeTags();

    return 0;
}

void runParse(FILE *infile, FILE *outfile)
{
    register int ch;
    
    
    while ((ch = fgetc(infile)) != EOF) {
        if (ch == '<')
            parseTag();
        else
            (void)fputc(ch, outfile);
    }
}


void usage(void)
{

    (void)fprintf(stderr, "usage:  rss2html [-i infile] [-o outfile] [-u user defined tag file]\nQuestions?  mercadal@khons.diablonet.net\n");
    exit(1);
}